# Anananas

## Bundled modules

- application
- scp (upload)
- webpack (install, build)
- docker (build, upload, deploy)

## Nouveautés

- revamped directory structure (etc/modules, etc/profiles)
- Concentré sur le build

## Stages

- build : builds project (ORM generation, assets compilation, etc)
- configure : configures sources
- deploy : deploys local sources to remote servers
- init : makes project compatible with the Anananas
- install : installs dependencies (composer, npm, etc)
- package : creates build archive (phar, tar, etc)
- upload : uploads package to artifact repository

## Formalisme de nommage des propriétés de module services

service.${servicetype}.${serviceinstance}.property

eg. :
- service.mysql.master.host
- service.elasticsearch.1.port
- service.rabbitmq.1.user

## TODO

- []  [anananas      ] renommer le projet en constructions-incongrues/anananas : packagist
- []  [anananas      ] .gitignore par défaut (configuration.env)
- []  [configuration ] implémenter une tâche de suppression des fichiers générés par `configuration.apply` appelée `configuration.reset`
- []  [configuration ] implémenter une tâche permettant d'ajouter les pendants des fichiers dist à .gitignore appelée `configuration.ignore`
- []  [configuration ] implémenter une macro pour nettoyer l'échappement des caractères produit par la tâche `echoproperties`
- []  [configuration ] .dotenv : les propriétés avec des noms comportant des _ ne se mettent pas correctement en majuscules
- []  [configuration ] .update : générer automatiquement des liens vers la documentation des propriétés lors de la regénération du profil
- []  [configuration ] .update : tout le système de buffer sent assez mauvais, à revoir
- []  [toolkit       ] .init : reprendre la tâche d'init pour en faire qqch de plus générique et automatique (là tout dépend du chemin du module `toolkit`)
- []  [toolkit       ] .init : permettre de déclarer des includes et des excludes
- []  [doc           ] écrire un tutoriel pour créer un projet Symfony et le faire fonctionner avec Docker
- []  [doc           ] identifier et publier une licence
- []  [doc           ] rédiger un document CONTRIBUTING
- []  [doc           ] terminer la documentation du module `configuration` (ne pas oublier la nouvelle notion de properties en buffer.*)
- []  [blueprint     ] permettre d'utiliser des blueprints externes
- []  [toolkit       ] toolkit.module.enable => http://ant.apache.org/manual/Tasks/propertyfile.html
- []  [wrapper       ] anananas shell code crashes when executed by `/bin/sh` => détecter le shell et désactiver la coloration pour les shells incompatibles
- []  [toolkit       ] faire en sorte que les tokens dans fichiers copiés depuis le module vers le profil de configuration soit remplacés lors de la phase d'init
- [x] [blueprint     ] introduire la notion de base blueprints (blueprint.create -Dblueprint.base=)
- [x] [configuration ] .update : supprimer les sauts de ligne en trop
- [x] [configuration ] la tâche `configuration.dotenv` devrait exporter all.properties et pas seulement les valeurs présentes dans profil de configuration
- [x] [configuration ] la tâche `configuration.update` ne doit pas déréférencer les substitutions dans le profil de configuration
- [x] [dotenv        ] il faut effectuer la substitution avant de transformer les nom de variables en shell compliant
- [x] [dotenv        ] soucis avec les lignes blanches dans les profils de configuration (=> =undefined)
- [x] [toolkit       ] renommer les fichier de properties des modules : configuration.properties => module.properties
- [x] [toolkit       ] renommer les fichier de properties des modules : configuration.properties => module.properties
- [x] [toolkit       ] il faut descendre le chargement des propriétés du profil (pour profiter des valeurs des modules mandatory) => mais du coup ça pose un problème avec `application.domain=local`
- [x] [wrapper       ] écrire un wrapper `anananas`
